package application2;

import library.annotations.*;
import application2.interfaces.*;

public class Account implements FlatModelWithOptimisticConcurrencyObject
{
	private int balance;
	private float interestRate;
	
	public Account(int startingBalance, int startingRate)
	{
		balance = startingBalance;
		interestRate = startingRate;
	}
	
	@ReadAccess 
	public int getBalance() 
	{
		return balance;
	}
	
	@WriteAccess 
	public void setBalance(int newBalance) 
	{
		balance = newBalance;
	}
	
	@ReadAccess 
	public float getInterestRate() 
	{
		return interestRate;
	}
	
	@WriteAccess 
	public void setInterestRate(float newRate) 
	{
		interestRate = newRate;
	}
	
	@UpdateAccess
	public void incrementBalanceIfLow()
	{
		if(balance < 300)
			balance = balance + 400;
	}
	
}
