package glassbox.installer.perContainer;

import glassbox.installer.BaseGlassboxInstaller;
import glassbox.util.DetectionUtils;

import java.io.*;
import java.util.Map;

import javax.servlet.ServletContext;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
 * Important? system properties:
 * catalina.base=/home/jheintz/bin/glassfish/domains/domain1
 * catalina.home=/home/jheintz/bin/glassfish/domains/domain1
 * com.sun.aas.webServicesLib=/home/jheintz/bin/glassfish/lib
 * com.sun.aas.instanceRoot=/home/jheintz/bin/glassfish/domains/domain1
 * shared.loader=${catalina.home}/shared/classes,${catalina.home}/shared/lib/*.jar
 * com.sun.enterprise.appname=j2ee
 * com.sun.aas.installRoot=/home/jheintz/bin/glassfish
 * getRealPath("/")=/home/jheintz/bin/glassfish/domains/domain1/applications/j2ee-modules/glassbox/
 *
 */
public class GlassfishGlassboxInstaller extends BaseGlassboxInstaller {
    private static final Log log = LogFactory.getLog(GlassfishGlassboxInstaller.class);

	/**
	 * Assume Weblogic 8 is always started in the right directory...
	 */
	public File getContainerHome() {
		return new File(getGlassfishHomeProperty());
	}
	
	public String getTargetSystemLabel() {
		return "GlassFish";
	}

	public File getScript() {
		return null; // never enabled for GlassFish (until we get some help)
	}
	
    public boolean matchesContext(ServletContext context) {
		return getGlassfishHomeProperty() != null;
	}
    
	public String getPlatformExtension() {
		if (isWindows())
			return ".bat";
		else
			return "";
	}

	public String getDefaultScriptPrefix() {
		return "asadmin";
	}	
	
	public File getDefaultScript() {
		File scriptFile = new File(getDefaultBinDirectory(), getDefaultScriptPrefix()+getPlatformExtension());
		return scriptFile;
	}
	
	public String getConfigureInstallerPageName() {
		return "configureInstaller_GlassfishInstaller";
	}

	public String getInstallerResultsPageName() {
		return "installerResults_GlassfishGlassboxInstaller";
	}
	
	String getGlassfishHomeProperty() {
		return System.getProperty("com.sun.aas.instanceRoot");
		
	}
}
