/********************************************************************
 * Copyright (c) 2005 Glassbox Corporation, Contributors.
 * All rights reserved. 
 * This program along with all accompanying source code and applicable materials are made available 
 * under the terms of the Lesser Gnu Public License v2.1, 
 * which accompanies this distribution and is available at 
 * http://www.gnu.org/licenses/lgpl.txt 
 *  
 * Contributors: 
 *     Ron Bodkin     initial implementation 
 *******************************************************************/
package glassbox.util.logging.api;

import glassbox.util.org.sl4j.Logger;

/** 
 * Interface of operations that an object that owns a log can perform on that log.
 * This would be cleaner with Java 5's static import feature, with advice defined on calls.
 */
public interface LogOwner {
    introduced boolean isDebugEnabled();
   // boolean isWarnEnabled();
    introduced void logError(String message);
    introduced void logError(String message, Throwable throwable);
    introduced void logWarn(String message);
    introduced void logWarn(String message, Throwable throwable);
    introduced void logInfo(String message);
    //void logInfo(String message, Throwable throwable);
    introduced void logDebug(String message);
    introduced void logDebug(String message, Throwable throwable);
    introduced Logger getLogger();
}

/*
glassbox.util.logging.api.LogManagement LogOwner.logDebug java.lang.String java.lang.Throwable
glassbox.util.logging.api.LogManagement LogOwner.logWarn java.lang.String
glassbox.util.logging.api.LogManagement LogOwner.logError java.lang.String java.lang.Throwable
glassbox.util.logging.api.LogManagement LogOwner.getLogger
glassbox.util.logging.api.LogManagement LogOwner.logWarn java.lang.String java.lang.Throwable
glassbox.util.logging.api.LogManagement LogOwner.logError java.lang.String
glassbox.util.logging.api.LogManagement LogOwner.logInfo java.lang.String
glassbox.util.logging.api.LogManagement LogOwner.logDebug java.lang.String
glassbox.util.logging.api.LogManagement LogOwner.isDebugEnabled
 */
