package library.aspects.context;

import library.interfaces.Pausable;
import library.interfaces.ExitSynchronizing;
import library.interfaces.PausableExitSynchronizing;

import library.util.Debugger;

public aspect PausableExitSynchronizingAspect 
{
	//declare parents: PausableExitSynchronizing implements Pausable/*, ExitSynchronizing*/;

	pointcut pausingActivation(PausableExitSynchronizing context):
		call(public void pause()) && target(context);
	
	after(PausableExitSynchronizing context) : pausingActivation(context)
	{
		Debugger.printMessage("PausableExitSynchronizing",Debugger.CONTEXT_ASPECT,context,"The participants, which are waiting at the exit of the context, will be taken into account during the pausing process.",1);

		int numberOfWaiters = context.getNumberOfWaitingMembers();
		
		int numberToBePaused = context.getNumberOfMembersToPause();
		
		context.setNumberOfMembersToPause(numberToBePaused - numberOfWaiters);
		
		Debugger.printMessage("PausableExitSynchronizing",Debugger.CONTEXT_ASPECT,context,"The participants, which are waiting at the exit of the context, have been taken into account during the pausing process.",2);
	}
}
