package library.aspects.context;

import library.interfaces.Recovering;
import library.interfaces.Tracing;
import library.interfaces.OutcomeAware;

import library.util.Debugger;

public aspect RecoveringAspect 
{
	//declare parents: Recovering implements /*OutcomeAware,*/ Tracing;
	
	pointcut recoveryTime(Recovering context) : 
		target(context) && call(public void Tracing.finalizeTraces());
	
	Object around(Recovering context) : recoveryTime(context)
	{
		Debugger.printMessage("Recovering",Debugger.CONTEXT_ASPECT,context,"The finalization of tracks call has been intercepted",2);
		
		if(!context.hasPositiveOutcome())
		{	
			Debugger.printMessage("Recovering",Debugger.CONTEXT_ASPECT,context,"Recovery won't let Tracing finalize the traces of the context.",1);
			
			return null;
		}
		else
		{
			Debugger.printMessage("Recovering",Debugger.CONTEXT_ASPECT,context,"The finalization of tracks call is let to proceed",2);
			return proceed(context);
		}		
		
		
	}
}
