package library.aspects.context;

import library.interfaces.Terminatable;
import library.interfaces.ExitSynchronizing;
import library.interfaces.TerminatableExitSynchronizing;

import library.util.Debugger;

public aspect TerminatableExitSynchronizingAspect 
{
	declare parents: TerminatableExitSynchronizing implements Terminatable/*, ExitSynchronizing*/;

	pointcut pausingActivation(TerminatableExitSynchronizing context):
		call(public void terminate()) && target(context);
	
	before(TerminatableExitSynchronizing context) : pausingActivation(context)
	{
		Debugger.printMessage("TerminatableExitSynchronizing",Debugger.CONTEXT_ASPECT,context,"The synchronization at the exit is being deactivated.",1);
		
		context.setSynchronizationActive(false);

		Debugger.printMessage("TerminatableExitSynchronizing",Debugger.CONTEXT_ASPECT,context,"The synchronization at the exit has been deactivated.",2);
	}
}
