package library.aspects.object;

import library.interfaces.Checkpointable;
import library.interfaces.Copyable;

import java.util.Stack;

import library.util.Debugger;

public aspect CheckpointableAspect introduces Checkpointable
{
	//declare parents: Checkpointable implements Copyable;

	private Stack<Object> Checkpointable.checkPoints = new Stack<Object>();
	
	public void Checkpointable.setCheckPointList(Stack<Object> newList)
	{
		checkPoints = newList;
	}
	
	public Stack<Object> Checkpointable.getCheckPointList()
	{
		return checkPoints;
	}
	
	public void Checkpointable.establishCheckPoint() 
	{	
		Debugger.printMessage("Checkpointable",Debugger.OBJECT_ASPECT,this,"The object will now create a checkpoint of itself.",1);
		
		Checkpointable newCheckpoint = (Checkpointable) this.cloneState();
		
		Debugger.printMessage("Checkpointable",Debugger.OBJECT_ASPECT,this,"A new checkpoint has been established.",2);
		
		checkPoints.push(newCheckpoint);
				
		Debugger.printMessage("Checkpointable",Debugger.OBJECT_ASPECT,this,"The process of establishing a checkpoint has been completed.",2);
	}
	
	public void Checkpointable.restoreCheckPoint()
	{	
		Debugger.printMessage("Checkpointable",Debugger.OBJECT_ASPECT,this,"The object will now restore its checkpoint.",1);
		
		Object previousState = checkPoints.pop();
		
		this.replaceState(previousState);
		
		Debugger.printMessage("Checkpointable",Debugger.OBJECT_ASPECT,this,"The most recent checkpoint has been restored.",2);
		
		Debugger.printMessage("Checkpointable",Debugger.OBJECT_ASPECT,this,"The process of restoring a checkpoint has been completed.",2);
	}
	
	public void Checkpointable.discardCheckPoint() 
	{
		checkPoints.pop();
		
		Debugger.printMessage("Checkpointable",Debugger.OBJECT_ASPECT,this,"The most recent checkpoint has been discarded.",1);
	}
}
