package library.aspects.object;

import java.util.Vector;
import library.interfaces.Named;

import library.util.Debugger;

public aspect NamedAspect introduces Named
{
	// Internal to the aspect //
	private static int IDGenerator = 0;
	//	 Internal to the aspect //
	
	// This aspect variable is not actually used in the framework
	// However it stores a reference to all the namedObjects
	private Vector<Named> namedObjects = new Vector<Named>();
	
	
	// Intertype declaration //
	private String Named.myName; 
	
	public String Named.getMyName()  
	{		
		return myName;
	}
    
	public void Named.setMyName(String newName)  
	{ 
		myName = newName; 
	}
    // Intertype declaration //
	
	
    /**
     * Intercepts the constructor execution of Named objects
     */
    pointcut constructorExecution(Named namedObject):
    	target(namedObject) && execution(public Named+.new(..));
    
    /**
     *  Assigns a unique name to every object of type Named after
     *  its creation
     */
    before(Named namedObject): constructorExecution(namedObject)
    {
    	Debugger.printMessage("Named",Debugger.OBJECT_ASPECT,namedObject,"Constructor Execution (before) call has been intercepted.",2);
    	
    	namedObject.setMyName(namedObject.getClass().getName() + ++IDGenerator);
    	
    	Debugger.printMessage("Named",Debugger.OBJECT_ASPECT,namedObject,"The object has been named as [" + namedObject.getMyName() + "].",1);
    	
    	namedObjects.add(namedObject);
    	
    	Debugger.printMessage("Named",Debugger.OBJECT_ASPECT,namedObject,"Constructor Execution (before) call has been returned.\n",2);
    	
    }

}
