package library.aspects.object;

import library.interfaces.Traceable;
import library.interfaces.Named;
import library.interfaces.AccessClassified;

import library.util.ObjectTrace;

import library.util.Debugger;

public aspect TraceableAspect introduces Traceable
{
	//declare parents: Traceable implements /*Named,*/ AccessClassified;

	public ObjectTrace Traceable.createMyTrace(String methodName)
	{
		Debugger.printMessage("Traceable",Debugger.OBJECT_ASPECT,this,"The object is asked to create a trace of itself.",2);
		
		String accessType = getAccessTypeOfMethod(methodName);
		
		ObjectTrace trace = new ObjectTrace(this,accessType);
		
		Debugger.printMessage("Traceable",Debugger.OBJECT_ASPECT,this,"A trace of the object has been established.",1);
				
		Debugger.printMessage("Traceable",Debugger.OBJECT_ASPECT,this,"The process of creating a trace of the object is completed.",2);
		
		return trace;
	}
}
