package library.util;

import library.interfaces.Traceable;
import java.io.Serializable;

public class ObjectTrace implements Serializable
{
	private Traceable trackedObject;
	private String accessType;
	
	public ObjectTrace(Traceable newObject, String newType)
	{
		trackedObject = newObject;
		accessType = newType;
	}
	public String getAccessType() 
	{
		return accessType;
	}
	
	public void setAccessType(String accessType) 
	{
		this.accessType = accessType;
	}
	
	public Traceable getTrackedObject() 
	{
		return trackedObject;
	}
	
	public String getTrackedObjectName()
	{
		Traceable trackableObject = (Traceable) trackedObject;
		
		return trackableObject.getMyName();
	}
	
	public void setTrackedObject(Traceable newObject) 
	{
		trackedObject = newObject;
	}
	
	public boolean equals(Object o)
	{
		ObjectTrace otherTrail = (ObjectTrace) o;
		
		boolean result = false;
		
		if(this.trackedObject ==  otherTrail.getTrackedObject() &&
				this.accessType.equals(otherTrail.getAccessType()))
			result = true;
		
		return result;
	}
	
	public int hashCode()
	{
		return accessType.hashCode() + trackedObject.hashCode();
	}
}
