package org.jhotdraw.ccconcerns.commands.undo;

import org.jhotdraw.standard.AbstractCommand;
import org.jhotdraw.util.Undoable;

/**
 * Undo support for Command elements
 * 
 * @author MariusMarin
 */
public aspect CommandUndo introduces CommandUndoRole {

	//Command - UndoableRole role
	
	/**
	 * define the subject role for figure selection
	 */
	
	// convert to ITD interfaces
    /*public interface CommandUndoRole extends GenericRole {
    	public Undoable getUndoActivity();
    	public void setUndoActivity(Undoable newUndoableActivity);
    }*/

	// ITD interfaces refactor 
	//declare parents: Command extends CommandUndoRole;
	
	// ITD interfaces extension
	public Undoable CommandUndoRole.getUndoActivity() {
		return null;
	}
	
	public void CommandUndoRole.setUndoActivity(Undoable newUndoableActivity) {}

    private Undoable AbstractCommand.myUndoableActivity;   
    
	public Undoable AbstractCommand.getUndoActivity() {
		return myUndoableActivity;
	}

	public void AbstractCommand.setUndoActivity(Undoable newUndoableActivity) {
		myUndoableActivity = newUndoableActivity;
	}

	
}
