package org.jhotdraw.ccconcerns.figures.persistence;

import org.jhotdraw.util.Storable;
import org.jhotdraw.util.StorableInput;
import org.jhotdraw.util.StorableOutput;
import org.jhotdraw.framework.Figure;

/**
 * General aspect to add the persistence concern to the Figure
 * classes.
 * 
 * @author Marius M.
 *
 */
public aspect PersistentFigure introduces Figure {

	// ITD interfaces refactor
	//declare parents: Figure extends Storable;

	/**
	 * Declares <code>write(..)</code> for persistent figures. 
	 * Stores the Figure to a StorableOutput.
	 */
	public void Figure.write(StorableOutput dw) {
		// default implementation for a Figure's write method 
	}
       
	/**
	 * Declares <code>read(..)</code> for persistent figures. 
	 * Reads the Figure from a StorableInput.
	 */
	public void Figure.read(StorableInput dr) /*@AJHD refactored throws IOException*/ { 
		// default implementation for a Figure's read method
	}
}
