package roadrecognition;

/*PROTECTED REGION ID(RoadMapImports) ENABLED START*/
//extra imports go here
import java.io.File;
import nu.xom.*;
/*PROTECTED REGION END*/

public aspect RoadMap introduces RecognizeRoad {
	
	private java.util.ArrayList  RecognizeRoad.sections = new java.util.ArrayList();
	private double  tollsystem.RoadMap.tolerance  =  0 ;


	public java.util.ArrayList tollsystem.RoadMap.getSections(){
		return sections;
	}
	
	public void tollsystem.RoadMap.addSections(tollsystem.RoadSection object) {
        this.sections.add(object);
	}
	
	public void tollsystem.RoadMap.removeSections(int index) {
        this.sections.remove(index);
    }
		
	public void tollsystem.RoadMap.setSections(java.util.ArrayList sections) {
		this.sections = sections;
	}
	public double  tollsystem.RoadMap.getTolerance() {
		return tolerance;
	}
			
	public void tollsystem.RoadMap.setTolerance(double  tolerance) {
		this.tolerance = tolerance;
	}

	public double RecognizeRoad.calculateDistance(tollsystem.Position position,tollsystem.RoadSection section) {
	  /*PROTECTED REGION ID(RoadMap.calculateDistance) ENABLED START*/
		tollsystem.Position p0 = position;
        tollsystem.Position p1 = section.getBegin();
        tollsystem.Position p2 = section.getEnd();

		return Math.abs ( (p2.getLatitude() - p1.getLatitude()) * 
					(p1.getLongitude() - p0.getLongitude()) - (p1.getLatitude() - p0.getLatitude()) 
					* (p2.getLongitude() - p1.getLongitude()) )
		            / Math.sqrt( (p2.getLatitude() - p1.getLatitude())
		            		*(p2.getLatitude() - p1.getLatitude()) 
		            		+ (p2.getLongitude() - p1.getLongitude())*(p2.getLongitude() - p1.getLongitude()) );
	  /*PROTECTED REGION END*/
	}
	public void  tollsystem.RoadMap.updateRoad(tollsystem.RoadSection roadSection) {
	  /*PROTECTED REGION ID(RoadMap.updateRoad) ENABLED START*/
      
	  /*PROTECTED REGION END*/
	}
	public void  tollsystem.RoadMap.init(String file) {
	  /*PROTECTED REGION ID(RoadMap.init) ENABLED START*/
		String fileName = "/road_map.xml";

		Builder builder = new Builder(true);
		File xmlFile = new File (fileName);		
		Element root = null;

		try {
			Document doc = builder.build(xmlFile);

			// Get root element <eventsequence-array>
			root = doc.getRootElement();

		} catch (Exception e) {
			e.printStackTrace();
		}	 
		
        // query the root element in order to find the serialNumber and store the serial number;
		Nodes roadNodes = root.query("//road");
		
		//	Note can not use Java 5 iterator because XOM collection type is not compatible.
		for(int i=0; i < roadNodes.size(); i++) {
			getSectionData(roadNodes.get(i));
		}
	  /*PROTECTED REGION END*/
	}
	public tollsystem.RoadSection RecognizeRoad.recognizeRoad(tollsystem.Position position) {
	  /*PROTECTED REGION ID(RoadMap.recognizeRoad) ENABLED START*/
		// Shortest distance from a position to a section
		// unit of (shortest-)distance is degree
		double shortestDistance = 360;
		tollsystem.KindOfRoad kindOfRoad = KindOfRoad.UNKNOWN;
		tollsystem.RoadSection road = null;
		java.util.Iterator it = sections.iterator();
		while(it.hasNext())
		{
			tollsystem.RoadSection section = (tollsystem.RoadSection)it.next();
			// check whether the position is actually perpendicular to the section,
            // for this delta has to be 0 <= delta <= 1
            double delta = determineCrossPoint (section, position);
			if(delta>=0 && delta<=1){
				double distance = calculateDistance (position, section);
				System.out.println("RoadMap.recognize: distance = " + distance);
		    	System.out.println("RoadMap.recognize() distance "+distance);
				if(distance < shortestDistance){
					shortestDistance = distance;
					road = section;
				}
            }
			else System.out.println("RoadMap.recognize: not perpendicular");
		}
		return road;
	  /*PROTECTED REGION END*/
	}
	public double RecognizeRoad.determineCrossPoint(tollsystem.RoadSection section,tollsystem.Position position) {
	  /*PROTECTED REGION ID(RoadMap.determineCrossPoint) ENABLED START*/
		tollsystem.Position p0 = position;
        tollsystem.Position p1 = section.getBegin();
        tollsystem.Position p2 = section.getEnd();
        
        tollsystem.Position p2minusp1 = minus(p2,p1);
        tollsystem.Position p0minusp1 = minus(p0,p1);
        return scalarProduct (p0minusp1, p2minusp1)/scalarProduct (p2minusp1, p2minusp1);
	  /*PROTECTED REGION END*/
	}
	public double RecognizeRoad.scalarProduct(tollsystem.Position a,tollsystem.Position b) {
	  /*PROTECTED REGION ID(RoadMap.scalarProduct) ENABLED START*/
		return a.getLatitude() * b.getLatitude() + a.getLongitude() * b.getLongitude(); 
	  /*PROTECTED REGION END*/
	}
	public tollsystem.Position RecognizeRoad.minus(tollsystem.Position a,tollsystem.Position b) {
	  /*PROTECTED REGION ID(RoadMap.minus) ENABLED START*/
		tollsystem.Position result = new tollsystem.Position();
    	result.setLatitude(a.getLatitude() - b.getLatitude());
    	result.setLongitude(a.getLongitude() - b.getLongitude());
        return result;
	  /*PROTECTED REGION END*/
	}
	/*PROTECTED REGION ID(RoadMapAspect) ENABLED START*/ 
    //extra methods go here

	/**
	 * This method is only used from the init method.
	 * It is used to add sections to the road map.
	 * 
	 * @param sectionNode This is a road section object.
	 */
	public void tollsystem.RoadMap.getSectionData(Node sectionNode) {

		Nodes sectionsNodes = sectionNode.query("section");

		// Note can not use Java 5 iterator because XOM collection type is not compatible.
		for (int sectionCounter = 0; sectionCounter < sectionsNodes.size(); sectionCounter++) {
			Element section = (Element)sectionsNodes.get(sectionCounter);
			String typeOfSection = section.getAttributeValue("type");
			double nominalCost = Double.parseDouble(section.query("nominalCost").get(0).getValue());

			Nodes beginXNode = section.query ("beginx");
			double beginX = Double.parseDouble(beginXNode.get(0).getValue());

			Nodes beginYNode = section.query ("beginy");
			double beginY = Double.parseDouble(beginYNode.get(0).getValue());

			Nodes endXNode = section.query ("endx");
			double endX = Double.parseDouble(endXNode.get(0).getValue());

			Nodes endYNode = section.query ("endy");
			double endY = Double.parseDouble(endYNode.get(0).getValue());

			tollsystem.Position start = new tollsystem.Position ();
			start.setLatitude(beginX);
			start.setLongitude(beginY);
			start.setQuality((byte)0);
			tollsystem.Position end = new tollsystem.Position ();
			end.setLatitude(endX);
			end.setLongitude(endY);
			end.setQuality((byte)0);
			tollsystem.RoadSection s = new tollsystem.RoadSection();
			s.setBegin(start);
			s.setEnd(end);
			s.setNominalCost(nominalCost);
			if(typeOfSection.equals("highway"))
				s.setKindOfRoad(KindOfRoad.HIGHWAY);
			else if(typeOfSection.equals("motorway"))
				s.setKindOfRoad(KindOfRoad.MOTORWAY);
			else
				s.setKindOfRoad(KindOfRoad.UNKNOWN);
			this.sections.add(s);
		}
	}
    /*PROTECTED REGION END*/
}
	
